// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

import net.cellcomputing.himawari.accessory.STLVector;
import net.cellcomputing.himawari.library.types.CqVector2D;

/**
 * 
 * トリミングループを配列としてまとめて扱うクラス。<br>
 * その一つ一つが CqTrimLoopでループとなる。
 * 
 * @author NTT DATA Corporation
 */
public strictfp class CqTrimLoopArray {
	
	/** defurlt constructer */
	public CqTrimLoopArray(){}
	
	/** destructer */
	public void destract(){}
	
	/**
	 * プリミティブを切り取るトリミングループのベクタを返す。
	 * 
	 * @return	m_aLoops	トリミングループ
	 */
	public STLVector<CqTrimLoop> aLoops()
	{
		return ( m_aLoops );
	}
	
	
	/**
	 * トリミングする軌跡の点を決定する。
	 * 
	 * @param pSurface	トリミングする面
	 */
	public void	Prepare( CqSurface pSurface )
	{
		for ( CqTrimLoop iLoop : m_aLoops )
			iLoop.Prepare( pSurface );
	}
	
	
	/**
	 * テストポイントが内側にあるか外側にあるかを判定する。
	 * 
	 * @param 　v	位置を調べる点の座標
	 * @return	true(内側) / false(外側)
	 */
	public	boolean	TrimPoint( final CqVector2D v )
	{
		// Early out if no trim loops at all.
		if ( m_aLoops.size() == 0 )
			return ( false );
		
		// テストポイントが内側だった場合のカウンタ
		int	cCrosses = 0; 
		for ( CqTrimLoop iLoop : m_aLoops )
			cCrosses += iLoop.TrimPoint( v )? 1 : 0;
		
		//　奇数ならばtrue, 偶数ならばfalse
		return ( ( cCrosses & 1 ) == 0 );
	}
	
	
	/**
	 * 線分がトリミング図形と交点を持つかどうかの判定を行う。
	 * 
	 * @param 	v1	線分を構成する点座標
	 * @param 	v2	線分を構成する点座標
	 * @return	true(交点有り) / false(交点なし)
	 */
	public	boolean	LineIntersects(final CqVector2D v1, final CqVector2D v2)
	{
		// Early out if no trim loops at all.
		if ( m_aLoops.size() == 0 )
			return ( false );
		
		for ( CqTrimLoop iLoop : m_aLoops ){
			if(iLoop.LineIntersects( v1, v2 ))
				return(true);
		}
		return ( false );
	}
	
	
	/** トリミングループをクリアする。 */
	void	Clear()
	{
		m_aLoops.clear();
	}
	
	private   STLVector<CqTrimLoop>	m_aLoops = new STLVector<CqTrimLoop>( CqTrimLoop.class );
	
	
}
